田草博客
日志搜索


 标题   内容 评论


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件
-电信用户-|-网通用户-
-博客论坛-|-软件下载-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2018 - 12 48
      1
2345678
9101112131415
16171819202122
23242526272829
3031


站点统计

最新评论



关于起名应注意的事项 扒灰
未知 点监视器和Hook的结合应用   [ 日期:2018-02-26 ]   [ 来自:本站原创 ]  HTML


http://bbs.xdcad.net/thread-709250-1-1.html

Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.Runtime

Public Class MyCommands

    Const WM_KEYDOWN As Integer = 256
    Const WM_KEYUP As Integer = 257
    Const WM_SYSKEYDOWN As Integer = 260
    Const WM_SYSKEYUP As Integer = 261

    Private _curEditor As Editor
    Private _mObjectId As ObjectId = ObjectId.Null

    Private _mScalefactor As Double
    Private _mTolerance As Tolerance

    Private Sub UpDownKeyHandler(ByVal sender As Object, ByVal e As PreTranslateMessageEventArgs)
        Select Case e.Message.message
            Case WM_KEYDOWN
                Dim ptr = e.Message.wParam.ToInt32()
                Select Case ptr
                    Case 37
                        If _mScalefactor > 0.5 Then
                            _mScalefactor -= 0.1
                        End If
                        Exit Select
                    Case 39
                        _mScalefactor += 0.1
                        Exit Select
                    Case Else
                        Exit Select
                End Select
                Exit Select
            Case WM_SYSKEYDOWN
                Exit Select
            Case WM_KEYUP
                Exit Select
            Case WM_SYSKEYUP
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub


    Private Sub My_PointMonitor(ByVal sender As Object, ByVal e As PointMonitorEventArgs)
        If _mObjectId = ObjectId.Null Then
            Return
        End If
        Dim db = Application.DocumentManager.MdiActiveDocument.Database
        Try
            Using tr = db.TransactionManager.StartTransaction()
                Dim scl = _mScalefactor
                Dim blk = CType(tr.GetObject(_mObjectId, OpenMode.ForWrite), BlockReference)
                If blk IsNot Nothing Then
                    If Not blk.Position.IsEqualTo(e.Context.ComputedPoint) Then
                        blk.Position = e.Context.ComputedPoint
                    End If
                    blk.ScaleFactors = New Scale3d(scl)
                End If
                tr.Commit()
            End Using
        Catch generatedExceptionName As System.Exception
            Throw
        End Try
    End Sub

    <CommandMethod("myinsert")> _
    Public Sub MyInsert()
        Dim doc = Application.DocumentManager.MdiActiveDocument
        _curEditor = doc.Editor
        _mTolerance = New Tolerance(0.001, 0.001)
        _mScalefactor = 1.0
        Dim db = doc.Database
        Try
            Dim peo As New PromptEntityOptions(vbLf & "Select Insert")
            peo.SetRejectMessage("**Only Insert*")
            peo.AddAllowedClass(GetType(BlockReference), True)
            Dim per = _curEditor.GetEntity(peo)
            If per.Status <> PromptStatus.OK Then
                Return
            End If
            _mObjectId = per.ObjectId
            AddHandler Application.PreTranslateMessage, AddressOf UpDownKeyHandler
            AddHandler _curEditor.PointMonitor, AddressOf My_PointMonitor
            Dim ppo = New PromptPointOptions(vbLf & "Position")
            Dim ppr = _curEditor.GetPoint(ppo)
            If ppr.Status <> PromptStatus.OK Then
                Return
            End If
            RemoveHandler Application.PreTranslateMessage, AddressOf UpDownKeyHandler
            RemoveHandler _curEditor.PointMonitor, AddressOf My_PointMonitor
        Catch generatedExceptionName As System.Exception
            _curEditor.WriteMessage(vbLf & "*error*")
        Finally
            RemoveHandler Application.PreTranslateMessage, AddressOf UpDownKeyHandler
            RemoveHandler _curEditor.PointMonitor, AddressOf My_PointMonitor
        End Try
    End Sub


End Class





暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:1*3=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©